#!/usr/bin/perl

# RoadHog Search CGI version 1.0
# (c) 2001 Frederik Ramm
# http://www.remote.org/frederik/roadhog/software/
# released under GPL

use String::Similarity;
use CGI;

$maxdist = 10;
$query = CGI::new ();

# --- language detection code start

my $setlang = $query->param("lang");
my $acceptlang = $ENV{"HTTP_ACCEPT_LANGUAGE"};
my $lang = "en";

if (defined ($acceptlang))
{
	my $de = index ($acceptlang, "de");
	my $en = index ($acceptlang, "en");
	if (($de > -1) && (($en == -1) || ($de < $en)))
	{
		$acceptlang = "de";
	}
	else
	{
		$acceptlang = "en";
	}
}
else
{
	$acceptlang = "en";
}

if ($setlang eq "en")
{
	$carryon{"lang"} = "en" unless ($acceptlang eq "en");
	$appendlang = ".en" unless ($acceptlang eq "en");
	$lang = "en";
} 
elsif ($setlang eq "de")
{
	$carryon{"lang"} = "de" unless ($acceptlang eq "de");
	$appendlang = ".de" unless ($acceptlang eq "de");
	$lang = "de";
}
else
{
	$lang = $acceptlang;
}

if ($lang eq "en")
{
	$word{"faster"} = "faster";
	$word{"slower"} = "slower";
	$word{"pause"} = "pause";
	$word{"continue"} = "continue";
	$word{"forward"} = "forward";
	$word{"back"} = "back";
	$word{"restart"} = "restart";
	$word{"toend"} = "to end";
	$word{'css_no'} = "Do not use CSS";
	$word{'css_yes'} = "Use CSS positioning";
	$word{'frm_no'} = "Do not use Frames";
	$word{'frm_yes'} = "Use Frames";
	$word{'java_no'} = "No Java";
	$word{'java_yes'} = "Use Java";
	$word{'java_err'} = "Your browser doesn't display the Java applet.";
	$word{'frame_err'} = "Your browser doesn't display frames.";
	$word{'frame_err_click'} = "Click here to return to a non-frame version.";
	$word{'title'} = "On the Road in North-West Scotland";
	$word{'placelist'} = "Place List";
	$word{'search'} = "Search";
	$word{'helpfaq'} = "Help &amp; FAQ";
	$word{'problem'} = "Sorry but there seems to be a technical problem. If this condition ".
	  "persists, please contact frederik\@remote.org with a detailed description! ".
	  "A detailed message appears below.";
	$word{'tiny'} = "tiny";
	$word{'small'} = "small";
	$word{'medium'} = "medium";
	$word{'large'} = "large";
	$word{'huge'} = "huge";
	$word{'grid'} = "OSGS Grid";
	$word{'latitude'} = "Latitude";
	$word{'longitude'} = "Longitude";
	$word{'metres'} = "metres";
	$word{'metres-nom'} = "metres";
	$word{'kilometres'} = "kilometres";
	$word{'enterplace'} = "Enter a place name:";
	$word{'examples'} = "Examples";
	$word{'OR'} = "OR";
	$word{'enterloc'} = "Enter a location:";
	$word{'coordmagic'} = "most formats magically recognized, either lat/long according to WGS-84 ".
		"or grid values according to British National Grid";
	$word{'east'} = "East";
	$word{'north'} = "North";

}
elsif ($lang eq "de")
{
	$word{"faster"} = "schneller";
	$word{"slower"} = "langsamer";
	$word{"pause"} = "halt";
	$word{"continue"} = "weiter";
	$word{"forward"} = "vor";
	$word{"back"} = "zurck";
	$word{"restart"} = "erstes";
	$word{"toend"} = "ans ende";
	$word{'css_no'} = "Kein CSS";
	$word{'css_yes'} = "CSS-Positionierung";
	$word{'frm_no'} = "Keine Frames";
	$word{'frm_yes'} = "Frames benutzen";
	$word{'java_no'} = "Kein Java";
	$word{'java_yes'} = "Java einschalten";
	$word{'java_err'} = "Ihr Browser zeigt das Java-Applet nicht an.";
	$word{'frame_err'} = "Ihr Browser zeigt keine Frames an.";
	$word{'frame_err_click'} = "Klicken Sie hier, um zu einer Version ohne Frames zurckzukehren.";
	$word{'title'} = "Unterwegs in Nordwestschottland";
	$word{'placelist'} = "Ortsliste";
	$word{'search'} = "Suche";
	$word{'helpfaq'} = "Hilfe &amp; FAQ";
	$word{'problem'} = "Es gibt ein technisches Problem. Wenn diese Meldung wiederholt auftritt, ".
	  "dann melden Sie sich bitte bei frederik\@remote.org mit einer genauen Beschreibung! ".
	  "Eine detaillierte Meldung folgt unten.";
	$word{'tiny'} = "mini";
	$word{'small'} = "klein";
	$word{'medium'} = "mittel";
	$word{'large'} = "gro";
	$word{'huge'} = "riesig";
	$word{'grid'} = "OSGS-Koordinaten";
	$word{'latitude'} = "Lngengrad";
	$word{'longitude'} = "Breitengrad";
	$word{'metres'} = "Metern";
	$word{'metres-nom'} = "Meter";
	$word{'kilometres'} = "Kilometern";
	$word{'enterplace'} = "Geben Sie einen Ortsnamen an:";
	$word{'examples'} = "Beispiele";
	$word{'OR'} = "ODER";
	$word{'enterloc'} = "Geben Sie Koordinaten an:";
	$word{'coordmagic'} = "die meisten Formate werden erkannt, entweder Lnge/Breite nach WGS-84 ".
		"oder British National Grid-Werte";
	$word{'east'} = "Ost";
	$word{'north'} = "Nord";
}

# -- langauge detection code end
if (!(defined ($query->param ("place")) || defined ($query->param ("coord"))))
{
	header ("$word{'search'}");
	if ($lang eq "en")
	{
		print <<EOF;
You can search either for a place name or for co-ordinates. The
place names come from a database I've created manually, so not
<em>every</em> name will be there, but I have entered the names
of any villages, many farms and crofts, forests, rivers, glens,
lochs, and mountains I passed. <p>
The script will also find similar-sounding names (which is essential
around here since every map spells those ex-Gaelic names differently!).
EOF
	}
	elsif ($lang eq "de")
	{
		print <<EOF;
Sie knnen entweder nach einem Ortsnamen oder nach Koordinaten suchen.
Die Ortsnamen kommen von einer manuell erzeugten Datenbank, also wird nicht
<em>jeder</em> Name enthalten sein, aber ich habe viele Orte, Farmen, 
Crofts, Wlder, Flsse, Tler, Seen und Berge eingegeben, die einen 
Namen hatten.<p>
Das Skript findet auch hnlich geschriebene Namen (was unverzichtbar ist,
weil die glischen Namen auf jeder Karte anders buchstabiert sind!).
EOF
	}

	print "<p>";
	searchform ();
	footer ("");
}
else
{
	# form filled out
	
	if ($query->param ("place") ne "")
	{
		$orig_place = lc ($query->param ("place"));
		$place = lc ($query->param ("place"));
		open (PLACES, "control/places.txt.$lang") || trouble ("places.txt.$lang");
		while (<PLACES>)
		{
			chomp;
			last if (/^\s*$/);
			$route[$count++] = $_;
		}
		$minsim = 0.6;
		while (<PLACES>)
		{
			($word, $qualifier, $routes) = split(/:/);
			if ($word =~ /(.*)\*(.*)/)
			{
				$sim1 = similarity $place, lc ($1), $minsim;
				$sim2 = similarity $place, lc ("$1 $2"), $minsim;
				$sim = ($sim1 > $sim2) ? $sim1 : $sim2;
			}
			else
			{
				$sim = similarity $place, lc ($word), $minsim;
			}
			if ($sim >= $minsim)
			{
				$key = $word . "_" . $qualifier;
				$match{$key}{"sim"} = $sim;
				$match{$key}{"ptr"} = $routes;
				$found++;
				$minsim = 1 if ($sim == 1)  
			}
		}
		close (PLACES);

		if ($found == 0)
		{
			if ($lang eq "en")
			{
				header ("Nothing found");
				print "No places matching your input were found.<hr><h3>Try again:</h3>";
			}
			elsif ($lang eq "de")
			{
				header ("Nichts gefunden");
				print "Keine Orte in der Datenbank passen zu Ihrem Suchwort.<hr><h3>Versuchen Sie's nochmal:</h3>";
			}
			searchform ();
		}
		else
		{ 
			if ($lang eq "en")
			{
				header ("Search Results");
				if ($minsim == 1)
				{
					print "Here's a list of routes that run through, past, along, or near the ";
					print "place you entered.\n";
				}
				else
				{
					print "Here's a list of routes that run through, past, along, or near some ";
					print "places that sound similar to what you entered.\n";
				}
				print "Note that this doesn't necessarily mean that the ";
				print "place/feature you are looking for is actually visible on one of the photos!\n";
			}
			else
			{
				header ("Suchergebnisse");
				if ($minsim == 1)
				{
					print "Hier ist eine Liste der Wegstrecken, die durch den genannten Ort oder ";
					print "in seiner Nhe verlaufen.\n";
				}
				else
				{
					print "Hier ist eine Liste der Wegstrecken, die durch einen Ort oder in der ";
					print "Nhe eines Ortes verlaufen, der hnlich geschrieben wird wie das Suchwort.\n";
				}
				print "(Das mu aber nicht heien, da das, wonach Sie suchen, auch tatschlich auf einem ";
				print "der Bilder zu sehen ist!)\n";
			}
			
			print "<dl>\n";
			@sorted = sort ( { $match{$b}{"sim"} <=> $match{$a}{"sim"} } keys (%match));
			$lastsim = 0;
			$outcount = 0;
			foreach $key (@sorted)
			{
				if ($match{$key}{"sim"} < $minsim)
				{
					last;
				}
				if (($match{$key}{"sim"} < $lastsim) && ($outcount > 5))
				{
					last;
				}
				$lastsim = $match{$key}{"sim"};
				$outcount++;
				($word, $qualifier) = split (/_/, $key);
				if ($lang eq "en")
				{
					print "<dt>Routes at/in/through/past <strong>";
				}
				else
				{
					print "<dt>Strecken bei/in/durch/entlang <strong>";
				}
				$word =~ s/\*/ /g;
				print $word;
				print " ($qualifier)" if ($qualifier ne "");
				print ":</strong></dt>\n<dd>";
				
				foreach $route (split /,/, $match{$key}{"ptr"})
				{
					($url, $text) = split (/:/, $route[$route]);
					print "<a href =\"roadhog.cgi?show=$url&lang=$lang\">$text</a>";
					print "\n<br>";
				}
			}
			print ("</dl>\n");
		}
		if ($lang eq "en")
		{
			print ("<p>End of search results.");
		}
		elsif ($lang eq "de")
		{
			print ("<p>Ende der Suchergebnisse.");
		}
		footer ("");	
	}
	elsif ($query->param ("coord") ne "")
	{
		$entered = $query->param ("coord");
		$use_osgrid = 0;
		if ($entered =~ /\s*N([BCDGHIMNO])\D*(\d*)\D+(\d*)/i)
		{
			$gridy = 500000;
			($square, $east, $north) = ($1, $2, $3);
			$pos = index ("VWXYZQRSTULMNOPFGHJKABCDE", $square);
			$gridx += ($pos % 5) * 100000;
			$gridy += int ($pos / 5) * 100000;
			$easting = substr ($east."00000", 0, 5);
			$northing = substr ($north."00000", 0, 5);
			$gridx += $easting;
			$gridy += $northing;
			$use_osgrid = 1;
		}
		if ($entered =~ /(\S{2,})\s+(\S{2,})/)
		{
			($lat, $lon) = ($1, $2);
		}
		elsif ($entered =~ /(\S{2,}?)\s*[,;:\/\-]\s*(\S{2,})/)
		{
			($lat, $lon) = ($1, $2);
		}
		elsif ($entered =~ /(\S{2,})([EW]\S+)/i)
		{
			($lat, $lon) = ($1, $2);
		}
		else
		{
			$error = 1;
		}
	
		if (($error != 1) && ($use_osgrid != 1))
		{
			$latns = 1; $lonew = 1;
			if ($lat =~ /(.*)([NS])(.*)/i)
			{
				$lat = "$1$3";
				$latns = (lc($2) eq "n") ? 1 : -1;
			}
			elsif ($lat =~ /(.*)-(.*)/)
			{
				$lat = "$1$2";
				$latns = -1;
			}
			if ($lon =~ /(.*)([EWO])(.*)/i)
			{
				$lon = "$1$3";
				$lonew = (lc($2) eq "w") ? -1 : 1;
			}
			elsif ($lon =~ /(.*)-(.*)/)
			{
				$lon = "$1$2";
				$lonew = -1;
			}

			$lat = parsecoord ($lat, $latns);
			$lon = parsecoord ($lon, $lonew);

			if (($lat < -90) || ($lat > 90) || ($lon < -180) || ($lon > 180))
			{
				$error = 1;
			}
		}
	
		if ($error == 1)
		{
			if ($lang eq "en")
			{
			header ("Bad Location");
			print <<EOF;
			The co-ordinates you entered could not be understood. Your input will
			be understood if you follow these hints:

			<h3>For Latitude/Longitude pairs (WGS-84 map datum)</h3>
			<ul>
			<li>enter latitude first, then longitude;
			<li>separate latitude and longitude by a space or comma
			<li>do not put a space or comma in your latitude or longitude
			<li>Enter latitude and longitude...<ul>
			<li>... either as degrees, minutes, and seconds,
				using any character but a decimal point as a separator: 5723'12"
			<li>... or as degrees and minutes, where minutes may have a decimal 
				point and a fraction: 5723.123'
			<li>... or as degrees with a fraction: 57.9876</ul>
			<li>Use a letter (N,S with latitude; E,W with longitude) to denote the 
				hemisphere you're talking about. You can also use signs with the
				degree specification - a negative latitude is south, and a negative
				longitude is west.
			</ul>
			A valid example for a full co-ordinate specification is: 
			<em>N5748.10' W00540.32'</em>. The specification 
			<em>57.80166,-5.672</em> is equally valid and describes (approximately)
			the same location.

			<h3>For British Grid (a.k.a. "Landranger Grid") co-ordinates</h3>
			<ul>
			<li>Enter the two-letter square designator first, followed by 
			    the "easting", a separator, and the "northing". 
		    <li>Any non-digit is permitted as a separator.
			<li>If you give easting and northing with less than five
			    digit precision (usual Landranger co-ordinates will be
				given with three digits), zeroes will be added to
				make five-digit numbers. 
		    <li>Co-ordinates outside the square designators
			    NB, NC, ND, NG, NH, NI, NM, NN, NO are not recognized
				(and not covered either).
			</ul>
			A valid grid specification is "NG 81837 85005". You could
			also write it, a bit less precisely, as "NG818,850". Both
			describe roughly the same point as the latitude/longitude
			pair given further up.
			<hr>
			<h3>Try again:</h3>
EOF
			}
			elsif ($lang eq "de")
			{
			header ("Ungltige Koordinaten");
			print <<EOF;
			Die Koordinaten, die Sie eingegeben haben, konnten nicht verarbeitet werden.
			So geht es richtig:

			<h3>Fr geographische Lngen und Breiten (nach WGS-84)</h3>
			<ul>
			<li>geben Sie erst die Lnge, dann die Breite an;
			<li>trennen Sie beides durch ein Komma oder Leerzeichen;
			<li>verwenden Sie keine Kommata oder Leerzeichen innerhalb der Lnge oder Breite;
			<li>Geben Sie Lnge und Breite...<ul>
			<li>... als Grad, Minuten und Sekunden mit beliebigem Trennzeichen (auer Dezimalpunkt)
				an: 5723'12"
			<li>... oder als Grad und Minuten, wobei die Minuten einen Dezimalpunkt und Kommastellen
				haben knnen: 5723.123'
			<li>... oder nur als Grad mit Dezimalpunkt und Kommastellen: 57.9876</ul>
			<li>Verwenden Sie einen Buchstaben (N,S fr Lnge, W,O fr Breite) um die 
				Hemisphre anzugeben. Sie knnen auch Vorzeichen verwenden, dann bedeutet eine
				negative Lnge Sden, und eine negative Breite Westen.
			</ul>
			Eine komplette Koordinaten-Angabe knnte so aussehen: 
			<em>N5748.10' W00540.32'</em>. Die Angabe
			<em>57.80166,-5.672</em> ist ebenso gltig und beschreibt ungefhr den gleichen
			Ort.

			<h3>Fr das britische System (auch "Landranger Grid")</h3>
			<ul>
			<li>Geben Sie den zwei-Buchstaben-Code fr den Kartenausschnitt zuerst an, dann
			    den Ost-Wert ("easting"), ein Trennzeichen, und den Nord-Wert ("northing").
		    <li>Alle nicht-Ziffern sind als Trennzeichen erlaubt.
			<li>Wenn Sie die Koordinaten mit weniger als fnf Ziffern angeben (blich sind
			    drei Ziffern), hngt das Programm Nullen an, um fnf Ziffern (volle Meter) zu erzeugen.
		    <li>Nur Koordinaten innerhalb der Kartenausschnitte
			    NB, NC, ND, NG, NH, NI, NM, NN, NO werden erkannt.
			</ul>
			Eine gltige Angabe wre "NG 81837 85005". Man knnte das auch, mit etwas geringerer
			Przision, als "NG818,850" schreiben. Beide Punkte beschreiben etwa den gleichen Ort
			wie das Koordinatenpaar weiter oben.
			<hr>
			<h3>Versuchen Sie's noch einmal:</h3>
EOF
			}
			searchform ();
			footer ("");
			exit 1;
		}
			
		if ($lang eq "en")
		{
			header ("Location search result");
		}
		elsif ($lang eq "de")
		{
			header ("Koordinaten-Suchergebnis");
		}

		if ($use_osgrid)
		{
			print "<table><tr><td>$word{'grid'}</td><td>";
			print "N$square";
			printf ("%03d %03d", $easting/100, $northing/100);
			print "<tr><td></td><td>($gridx $word{east}, $gridy $word{north})</td>";
			print "</table>\n";
		}
		else
		{
			print "<table cellpadding=0 cellspacing=0><tr><td>$word{'latitude'}:</td><td align=right>";
			$ll = $lat;
			if ($ll < 0)
			{
				print "S";
				$ll = -$ll;
			}
			else
			{
				print "N";
			}
			printf ("%02d", int ($ll));	
			$ll -= int ($ll);
			$ll *= 60;
			printf ("%02d'", int ($ll));	
			$ll -= int ($ll);
			$ll *= 60;
			printf ("%02d\"", int ($ll));	
			printf "</tr><td align=right>(%9.6f)</td>", $lat;

			print "<tr><td>$word{'longitude'}:</td><td align=right>";
			$ll = $lon;
			if ($ll < 0)
			{
				print "W";
				$ll = -$ll;
			}
			else
			{
				print ($lang eq "en") ? "E" : "O";
			}
			printf ("%03d", int ($ll));	
			$ll -= int ($ll);
			$ll *= 60;
			printf ("%02d'", int ($ll));	
			$ll -= int ($ll);
			$ll *= 60;
			printf ("%02d\"", int ($ll));	
			printf "</td><td align=right>(%9.6f)</td></table>", $lon;
		}

		print ("<p>");
		
		open (LOC, "control/location.txt.$lang") || trouble ("location.txt.$lang");
		while (<LOC>)
		{
			chomp;
			last if (/^\s*$/);
			$dist{$count} = 2000 * $maxdist;
			$route[$count++] = $_;
		}
		$_= <LOC>;
		($minlong, $maxlat, $longfactor, $latfactor) = split (/:/);
		$x = ($lon - $minlong) * $longfactor;
		$y = ($maxlat - $lat) * $latfactor;

		if ($use_osgrid)
		{
			$x = $gridx;
			$y = $gridy;
		}

		$miny = $y - $maxdist * 1000;
		$maxy = $y + $maxdist * 1000;
		$minx = $x - $maxdist * 1000;
		$maxx = $x + $maxdist * 1000;

		while (<LOC>)
		{
			if ($use_osgrid)
			{
				($dummy, $dummy, $px, $py, $route) = split(/:/);
			} 
			else
			{
				($px, $py, $dummy, $dummy, $route) = split(/:/);
			}
			next if ($px < $minx);
			next if ($py < $miny);
			next if ($px > $maxx);
			next if ($py > $maxy);

			$dist = sqrt ( ($px-$x)**2 + ($py-$y)**2 );
			if (!defined ($dist{$route}) || $dist{$route} > $dist)
			{
				$dist{$route} = $dist;
			}
			$found++;
		}
		close (LOC);

		if ($found == 0)
		{
			if ($lang eq "en")
			{
				print "There are no routes that lie within $maxdist kilometres of ";
				print "the location you entered.\n";
				print "<hr><h3>Try again:</h3>\n";
			}
			elsif ($lang eq "de")
			{
				print "Es gibt keine Fotos innerhalb von $maxdist Kilometern um ";
				print "die eingegebenen Koordinaten.\n";
				print "<hr><h3>Versuchen Sie's nochmal:</h3>\n";
			}
			searchform ();
			footer ("");
			exit 1;
		}

		print "<dl>";

		foreach $index (sort { $dist{$a} <=> $dist{$b} } keys (%dist))
		{
			if ($dist{$index} < 500)
			{
				$group = "500 $word{'metres'}";
			}
			elsif ($dist{$index} < 2000)
			{
				$group = "2 $word{'kilometres'}";
			}
			elsif ($dist{$index} < 5000)
			{
				$group = "5 $word{'kilometres'}";
			}
			else
			{
				$group = sprintf ("%d $word{'kilometres'}", $maxdist);
				last if ($dist{$index} > $maxdist * 1000);
			}	
			if ($lastgroup ne $group)
			{
				if ($lastgroup ne "")
				{
					if ($lang eq "en")
					{
						print "<br>\n<dt>Additionally, t";
					}
					elsif ($lang eq "de")
					{
						print "<br>\n<dt>Weiterer Umkreis: ";
					}
					$add = "";
				}
				else
				{
					if ($lang eq "en")
					{
						print "<dt>T";
						$add = " of the co-ordinates you entered";
					}
					elsif ($lang eq "de")
					{
						print "<dt>";
						$add = " um die angegebenen Koordinten";
					}
				}
				if ($lang eq "en")
				{
					print "he following routes contain at least one point within $group";
				}
				elsif ($lang eq "de")
				{
					print "Die folgenden Strecken enthalten mindestens ein Foto innerhalb von $group";
				}
				print "$add:\n<dd>\n";
				$lastgroup = $group;
			}

			($url, $text) = split (/:/, $route[$index]);
			print "<a href =\"roadhog.cgi?show=$url&lang=$lang\">$text</a>";
			if ($dist{$index} < 1000)
			{
				printf " <em>(%3d $word{'metres-nom'})</em>", int ($dist{$index} / 50 + 0.5) * 50;
			}
			else
			{
				printf " <em>(%3.1fkm)</em>", $dist{$index} / 1000;
			}
			print "\n<br>";
		}
		
		print ("</dl>");
		if ($lang eq "en")
		{
			print ("<p>End of search results.");
		}
		elsif ($lang eq "de")
		{
			print ("<p>Ende der Suchergebnisse.");
		}
		footer ("");

	}
}
print "\n";
			
sub parsecoord 
{
	my ($coor, $fac) = @_;
	if ($coor =~ /(\d+)[^0-9.]+(\d+(\.\d+)?)/)
	{
		$val = $1 + ($2 / 60);
	}
	elsif ($coor =~ /(\d+)\D+(\d+)(\D+(\d+))/)
	{
		$val = $1 + ($2 / 60) + ($4 / 3600);
	}
	elsif ($coor =~ /([0-9.]+)/)
	{
		$val = $1;
	}
	else
	{	
		$val = -1000;
	}
	$val  *= $fac;
	return ($val);
}
	
sub header {
	my ($title) = @_;

	if ($lang eq "en")
	{
		$ll = "<a href=\"search.cgi?lang=de\">Auf Deutsch</a>";
	}
	elsif ($lang eq "de")
	{
		$ll = "<a href=\"search.cgi?lang=en\">In English</a>";
	}

	print <<EOF;
Content-type: text/html

<html>
<head><title>$word{'title'} - $title</title>
<style type="text/css">
<!--
body { margin: 2%; background: #ffffee; color: black; }
p,td,th,h1,h2,h3,ul,ol,li,b,em,strong.dt,dd,dl { font-family: "New Century Schoolbook", Times, serif; color: black; }
a:visited { color: #551A8B; }
a:link { color: #0000EE; }
//-->
</style>

</head>
<body bgcolor=white text=black link=blue>
<table width=100% cellpadding=5>
<tr bgcolor="bbbbff"><td><table width=100% cellspacing=0 cellpadding=0 border=0>
<tr>
<td>
<font size=+2><b>$title</b></font>
</td>
<td align=right>
$ll
</td>
</tr>
</table>
</td></tr></table>
<p>
<table width=100%><tr><td>
EOF
}

sub footer {
	print "</table>";
	print "<table width=100%><tr bgcolor=\"#ccccaa\"><td><table width=100% cellpadding=0 cellpadding=0><tr><td><a href=\"index.html$appendlang\">$word{'placelist'}</a> &nbsp; <a href=\"search.cgi?lang=$lang\">$word{'search'}</a> &nbsp; <a href=\"faq.html$appendlang\">$word{'helpfaq'}</a></td><td align=right>v1.0</td></tr></table></td></tr></table>";
	print "</body></html>\n";
}

sub searchform {

	print <<EOF;
	<table>
	<tr>
	<td>
	<form method=post action="search.cgi">
	$word{'enterplace'}
	<td>
	<input type=text name=place>
	<td>
	<input type=submit>
	<tr>
	<td>
	<td colspan=2>
	<font size=-1><em>($word{'examples'}: "Dundonnell", "Loch Maree", "Glen Docherty")
		</em></font>
	<tr>
	<td colspan=3 align=center>
	<input type=hidden name=lang value="$lang">
	</form><br>
	--- $word{'OR'} ---
	<form method=post action="search.cgi">
	<tr>
	<td>
	$word{'enterloc'}
	<td>
	<input type=text name=coord>
	<td>
	<input type=submit>
	<input type=hidden name=lang value="$lang">
	</form>
	<tr>
	<td>
	<td colspan=2>
	<font size=-1><em>($word{'examples'}: "N55.1234,W5.9876", "N5748.10' W00540.32'",
	    "NG 739,711" - $word{'coordmagic'})</em></font>
	</table>
EOF

}

sub trouble ()
{
	my ($msg) = @_;
	header ("Problem");
	if ($lang eq "en")
	{
		print "<p>The search script has encountered a technical problem. If this ";
		print "condition persists, please contact the author at frederik\@remote.org.<p>";
		print "Additional fault information: <tt>$msg</tt><p>" if ($msg ne "");
	}
	elsif ($lang eq "de")
	{
		print "<p>Das Such-Skript hat ein technisches Problem. Wenn diese Meldung wiederholt ";
		print "auftritt, benachrichtigen Sie mich bitte unter frederik\@remote.org.<p>";
		print "Zustzliche Information: <tt>$msg</tt><p>" if ($msg ne "");
	}
	footer ("");
	exit (1);
}
	
